=== debian/changelog ===
openmodelica (1.18.1-1) unstable; urgency=low

  * Automatic git build
 -- OpenModelica Build System <build@openmodelica.org>  Wed, 22 Dec 2021 11:39:38 -0000
